// option_folder: folder option
// Copyright (C) 2004 GORRY.

#include "option_folder.h"

////////////////////////////////////////////////////////////////
// tH_IvVlݒ

int Option_Folder_Init(
	OPTION_FOLDER *of
) {
	memset( of, 0, sizeof(OPTION_FOLDER) );
	of->Stop = 1;
	of->FreeSpaceSize = 10000;
	of->Interval = 60;
	of->LogRotateSize = 100000;
	lstrcpy( of->TargetFolder, "C:\\record" );
	lstrcpy( of->TargetExt, "mpeg,m2p,mpg,m2v,m1v,m1p,mpa,mp2,wav" );

	return (0);
}

////////////////////////////////////////////////////////////////
// tH_IvṼpX쐬

int Option_Folder_GetPath(
	TCHAR *path
) {
	TCHAR modulepath[MAX_PATH+1];

	GetModuleFileName( NULL, modulepath, MAX_PATH );
	g_MakeFileName( modulepath, modulepath, "*.ini", path, g_MAKEFILENAME_MODE_FORCE );

	return (0);
}

////////////////////////////////////////////////////////////////
// tH_IvVǂݍ

int Option_Folder_Load(
	OPTION_FOLDER *of,
	TCHAR *filename
) {
	OPTION_FOLDER def;

	Option_Folder_Init( &def );

	of->Stop          = GetPrivateProfileInt( "Folder", "Stop"         , def.Stop         , filename );
	of->FindSubFolder = GetPrivateProfileInt( "Folder", "FindSubFolder", def.FindSubFolder, filename );
	of->DelSubFolder  = GetPrivateProfileInt( "Folder", "DelSubFolder" , def.DelSubFolder , filename );
	of->FreeSpaceSize = GetPrivateProfileInt( "Folder", "FreeSpaceSize", def.FreeSpaceSize, filename );
	of->Interval      = GetPrivateProfileInt( "Folder", "Interval"     , def.Interval     , filename );
	of->ToTrashCan    = GetPrivateProfileInt( "Folder", "ToTrashCan"   , def.ToTrashCan   , filename );
	of->DelReadOnly   = GetPrivateProfileInt( "Folder", "DelReadOnly"  , def.DelReadOnly  , filename );
	of->DelHidden     = GetPrivateProfileInt( "Folder", "DelHidden"    , def.DelHidden    , filename );
	of->LogRotateSize = GetPrivateProfileInt( "Folder", "LogRotateSize", def.LogRotateSize, filename );

	GetPrivateProfileString( "Folder", "TargetFolder", def.TargetFolder, of->TargetFolder, MAX_PATH, filename );
	GetPrivateProfileString( "Folder", "TargetExt", def.TargetExt, of->TargetExt, MAX_PATH, filename );

	if ( of->TargetFolder[lstrlen( of->TargetFolder )-1] != '\\' ) {
		lstrcat( of->TargetFolder, "\\" );
	}

	return (0);
}

////////////////////////////////////////////////////////////////
// tH_IvVۑ

int Option_Folder_Save(
	OPTION_FOLDER *of,
	TCHAR *filename
) {
	TCHAR str[SLEN];

	wsprintf( str, "%d", of->Stop );
	if ( !WritePrivateProfileString( "Folder", "Stop", str, filename ) ) goto err;

	wsprintf( str, "%d", of->FindSubFolder );
	if ( !WritePrivateProfileString( "Folder", "FindSubFolder", str, filename ) ) goto err;

	wsprintf( str, "%d", of->DelSubFolder );
	if ( !WritePrivateProfileString( "Folder", "DelSubFolder", str, filename ) ) goto err;

	wsprintf( str, "%d", of->FreeSpaceSize );
	if ( !WritePrivateProfileString( "Folder", "FreeSpaceSize", str, filename ) ) goto err;

	wsprintf( str, "%d", of->Interval );
	if ( !WritePrivateProfileString( "Folder", "Interval", str, filename ) ) goto err;

	wsprintf( str, "%d", of->ToTrashCan );
	if ( !WritePrivateProfileString( "Folder", "ToTrashCan", str, filename ) ) goto err;

	wsprintf( str, "%d", of->DelReadOnly );
	if ( !WritePrivateProfileString( "Folder", "DelReadOnly", str, filename ) ) goto err;
	
	wsprintf( str, "%d", of->DelHidden );
	if ( !WritePrivateProfileString( "Folder", "DelHidden", str, filename ) ) goto err;

	wsprintf( str, "%d", of->LogRotateSize );
	if ( !WritePrivateProfileString( "Folder", "LogRotateSize", str, filename ) ) goto err;

	if ( !WritePrivateProfileString( "Folder", "TargetFolder", of->TargetFolder, filename ) ) goto err;

	if ( !WritePrivateProfileString( "Folder", "TargetExt", of->TargetExt, filename ) ) goto err;
	{
		TCHAR *p1, *p2;
		TCHAR c;
		p1 = of->TargetExt;
		p2 = of->TargetExt;
		while (!0) {
			c = *(p1++);
			if ( c == '\0' ) break;
			if ( c != ' ' ) {
				*(p2++) = c;
			}
		}
		*(p2) = '\0';
	}

	return (0);

  err:;
	return (-1);
}


////////////////////////////////////////////////////////////////
// [EOF]
