// poi: find & delete target file
// Copyright (C) 2004 GORRY.

#include "poi.h"

typedef struct tagPOITHREADPARAM {
	OPTION_FOLDER *option;
	int testflag;
	HWND hwndnotify;
} POITHREADPARAM;

int Poi_Busy;

////////////////////////////////////////////////////////////////
// tH_XLăc[\z

static int CreateFolderNameTbl(
	FOLDERNAMETBL *foldernametbl,
	FILELIST *filelist,
	BOOL findsubfolder,
	TCHAR *targetext
) {
	int ret;
	HANDLE hfind = NULL;
	WIN32_FIND_DATA finddata;
	FILEENTRY *f;
	DWORD fileentrycount;
	FOLDERNAMETBL *ft;
	FOLDERNAMETBL *ft_prev = NULL;
	TCHAR path[MAX_PATH*2+1];

	if ( filelist->Entry == NULL ) {
		void *p;
		DWORD size;
		filelist->EntryCount = 0;
		size = DEFSIZE_FILEENTRY;
		p = malloc( sizeof(FILEENTRY) * size );
		if ( p == NULL ) {
			goto err_memory;
		}
		filelist->Entry = (FILEENTRY *)p;
		p = (DWORD *)malloc( sizeof(DWORD) * size );
		if ( p == NULL ) {
			goto err_memory;
		}
		filelist->EntryIdx = (DWORD *)p;
		filelist->EntrySize = size;
	}

	fileentrycount = 0;
	foldernametbl->EntryIdx = filelist->EntryCount;

	wsprintf( path, "%s*.*", foldernametbl->Path );
// LOG_Put_S1( "FindFirstFile: %s\n", path );
	hfind = FindFirstFile( path, &finddata );
	if ( hfind == INVALID_HANDLE_VALUE ) {
		goto err_findfile;
	}

	while (!0) {
// LOG_Put_S1( "file: %s\n", finddata.cFileName );
		if ( !lstrcmp( finddata.cFileName, "." ) ) {
		} else if ( !lstrcmp( finddata.cFileName, ".." ) ) {
		} else if ( finddata.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM ) {
		} else if ( finddata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
			if ( findsubfolder == FALSE ) {
				goto next;
			}
			ft = (FOLDERNAMETBL *)malloc( sizeof(FOLDERNAMETBL) );
			if ( ft == NULL ) {
				goto err_memory;
			}
			memset( ft, 0, sizeof(FOLDERNAMETBL) );
			wsprintf( path, "%s%s\\", foldernametbl->Path, finddata.cFileName );
			lstrcpyn( ft->Path, path, MAX_PATH );
			ft->Atr = finddata.dwFileAttributes;
			foldernametbl->SubFolder = ft;
			if ( ft_prev ) {
				ft_prev->Next = ft;
			}
			ret = CreateFolderNameTbl( ft, filelist, findsubfolder, targetext );
			if ( ret < 0 ) {
				return (ret);
			}
			ft_prev = ft;
		} else {
			int extmatch;
			TCHAR *extp;
			TCHAR fdir[MAX_PATH];
			TCHAR fbase[MAX_PATH];
			TCHAR fext[MAX_PATH];
			TCHAR ext[MAX_PATH+1];

			g_ParseFileName( finddata.cFileName, fdir, fbase, fext );
			extmatch = 0;
			extp = targetext;
			while ( *(extp) != '\0' ) {
				TCHAR *p = fext;
				TCHAR *q = ext;

				if ( *(fext) == '.' ) {
					p++;
					*(q++) = '.';
				}
				while ( *(extp) != '\0' ) {
					if ( *(extp) == ',' ) {
						extp++;
						break;
					}
					if ( *(extp) == '?' ) {
						if ( *(p) != '\0' ) {
							*(q++) = *(p++);
						} else {
							*(q++) = '?';
						}
						extp++;
						continue;
					}
					if ( *(extp) == '*' ) {
						lstrcpy(q, p);
						p += lstrlen(p);
						q += lstrlen(q);
						extp++;
						continue;
					}
					*(q++) = *(extp++);
					p++;
				}
				*(q) = '\0';
				if ( !lstrcmpi( ext, fext ) ) {
					extmatch = 1;
					break;
				}
			}
			if ( !extmatch ) goto next;

			if ( filelist->EntryCount >= filelist->EntrySize ) {
				void *p;
				DWORD size;
				size = filelist->EntrySize*2;
				p = realloc( filelist->Entry, sizeof(FILEENTRY)*size );
				if ( p == NULL ) {
					goto err_memory;
				}
				filelist->Entry = (FILEENTRY *)p;
				p = realloc( filelist->EntryIdx, sizeof(DWORD)*size );
				if ( p == NULL ) {
					goto err_memory;
				}
				filelist->EntryIdx = (DWORD *)p;
				filelist->EntrySize = size;
			}
			fileentrycount++;
			{
				DWORD c = filelist->EntryCount++;
				filelist->EntryIdx[c] = c;
				f = &filelist->Entry[c];
			}
			lstrcpyn( f->Name, finddata.cFileName, MAX_PATH );
			f->Folder = foldernametbl;
			f->Time = finddata.ftLastWriteTime;
			f->FileSize = (((__int64)finddata.nFileSizeHigh)<<32) + finddata.nFileSizeLow;
			f->Atr = finddata.dwFileAttributes;
		}

	  next:;
		if ( !FindNextFile( hfind, &finddata ) ) {
			if ( GetLastError() == ERROR_NO_MORE_FILES ) {
				goto endoffolder;
			}
			goto err_findfile;
		}
	}

  endoffolder:;
// LOG_Put_S1( "FindClose: %s\n", path );
	FindClose( hfind );
	foldernametbl->FileCount = fileentrycount;
	return (0);

  err_quit:;
	if ( hfind ) {
		FindClose( hfind );
	}
	return (ret);

  err_memory:;
// LOG_Put_S1( "Err_Memory\n", "" );
	ret = -1;
	goto err_quit;

  err_findfile:;
// LOG_Put_S1( "Err_FindFile\n", "" );
	ret = -2;
	goto err_quit;
}

////////////////////////////////////////////////////////////////
// tH_c[J

static int FreeFolderNameTbl(
	FOLDERNAMETBL *foldernametbl
) {
	FOLDERNAMETBL *ft;
	FOLDERNAMETBL *ft_next;

	ft = foldernametbl;
	while ( ft ) {
		if ( ft->SubFolder ) {
			FreeFolderNameTbl( ft->SubFolder );
		}
		ft_next = ft->Next;
		free( ft );
		ft = ft_next;
	}

	return (0);
}

////////////////////////////////////////////////////////////////
// t@CXgJ

static int FreeFileList(
	FILELIST *filelist
) {
	if ( filelist == NULL ) {
		return (0);
	}
	if ( filelist->EntryIdx ) {
		free( filelist->EntryIdx );
	}
	if ( filelist->Entry ) {
		free( filelist->Entry );
	}
	free( filelist );

	return (0);
}

////////////////////////////////////////////////////////////////
// fBXN󂫗eʏ𓾂

static int GetDiskFreeSpaceInfo(
	TCHAR *path,
	DISKFREESPACEINFO *dfsinfo
) {
typedef BOOL (WINAPI *fp_GetDiskFreeSpaceEx)( LPCTSTR, PULARGE_INTEGER, PULARGE_INTEGER, PULARGE_INTEGER );
	fp_GetDiskFreeSpaceEx fn_GetDiskFreeSpaceEx;
	ULARGE_INTEGER l1, l2, l3;
	DWORD t1, t2, t3, t4;
	int ret;
	TCHAR drvpath[MAX_PATH];
	TCHAR c;

	__try {
		fn_GetDiskFreeSpaceEx = (fp_GetDiskFreeSpaceEx)GetProcAddress( GetModuleHandle("kernel32.dll"), "GetDiskFreeSpaceExA" );
		if ( fn_GetDiskFreeSpaceEx ) {
			ret = fn_GetDiskFreeSpaceEx( path, &l1, &l2, &l3 );
			if ( ret == 0 ) {
				goto err_gdfse;
			}
			dfsinfo->FreeSpace = (((__int64)l1.HighPart)<<32) + l1.LowPart;
			dfsinfo->BytePerCluster = 1024;
		} else {
			lstrcpyn( drvpath, path, 3 );
			c = tolower( drvpath[0] );
			if ( !isalpha(c) ) {
				goto err_gdfs;
			}
			if ( drvpath[1] != ':' ) {
				goto err_gdfs;
			}
			ret = GetDiskFreeSpace( drvpath, &t1, &t2, &t3, &t4 );
			if ( ret == 0 ) {
				goto err_gdfs;
			}
			dfsinfo->FreeSpace = ((__int64)t1)*t2*t3;
			dfsinfo->BytePerCluster = t1*t2;
		}
	}
	_except(EXCEPTION_EXECUTE_HANDLER)
	{
 LOG_Put_S1( "Exception: GetDiskFreeSpace(%s)\n", path );
		return (-3);
	}

	return (0);

  err_gdfse:;
 LOG_Put_S1( "Error: fn_GetDiskFreeSpaceEx(%s)\n", path );
	return (-2);

  err_gdfs:;
 LOG_Put_S1( "Error: GetDiskFreeSpace(%s)\n", path );
	return (-1);
}

////////////////////////////////////////////////////////////////
// St@CXgt\[g

static FILELIST *SortEntry_filelist;

static int __cdecl SortEntry_Compare(
	const void *p1,
	const void *p2
) {
	DWORD i1 = *((DWORD *)p1);
	FILEENTRY *e1 = &(SortEntry_filelist->Entry[i1]);
	DWORD i2 = *((DWORD *)p2);
	FILEENTRY *e2 = &(SortEntry_filelist->Entry[i2]);

	if ( e1->Time.dwHighDateTime == e2->Time.dwHighDateTime ) {
		if ( e1->Time.dwLowDateTime == e2->Time.dwLowDateTime ) {
			return (0);
		} else if ( e1->Time.dwLowDateTime < e2->Time.dwLowDateTime ) {
			return (-1);
		} else {
			return (1);
		}
	} else if ( e1->Time.dwHighDateTime < e2->Time.dwHighDateTime ) {
		return (-1);
	} else {
		return (1);
	}
}

static int SortEntry(
	FILELIST *filelist
) {
	SortEntry_filelist = filelist;
	qsort(
	  filelist->EntryIdx, 
	  filelist->EntryCount, 
	  sizeof(DWORD),
	  SortEntry_Compare
	);

	return (0);
}

////////////////////////////////////////////////////////////////
// Ƀ\[gꂽt@Cꗗ𓾂

static int GetSortedFileList(
	OPTION_FOLDER *option_folder,
	FILELIST **ret_filelist,
	FOLDERNAMETBL **ret_foldernametbl
) {
	int ret;
	FILELIST *filelist = NULL;
	FOLDERNAMETBL *foldernametbl = NULL;
	TCHAR *path;

	path = option_folder->TargetFolder;

	filelist = (FILELIST *)malloc(sizeof(FILELIST));
	if ( filelist == NULL ) {
		goto err_memory;
	}
	foldernametbl = (FOLDERNAMETBL *)malloc(sizeof(FOLDERNAMETBL));
	if ( foldernametbl == NULL ) {
		goto err_memory;
	}
	memset( filelist, 0, sizeof(FILELIST) );
	memset( foldernametbl, 0, sizeof(FOLDERNAMETBL) );

	lstrcpyn( foldernametbl->Path, path, MAX_PATH );
	ret = CreateFolderNameTbl(
	  foldernametbl,
	  filelist,
	  option_folder->FindSubFolder,
	  option_folder->TargetExt
	);
	if ( ret < 0 ) {
		goto err_create;
	}

	ret = SortEntry( filelist );

	*(ret_filelist) = filelist;
	*(ret_foldernametbl) = foldernametbl;

	return (0);

  err_memory:;
	ret = -1;
	goto err_quit;

  err_create:;
	ret = -2;
	goto err_quit;

  err_quit:;
	if ( foldernametbl ) {
		FreeFolderNameTbl( foldernametbl );
	}
	if ( filelist ) {
		FreeFileList( filelist );
	}
	return (ret);
}

////////////////////////////////////////////////////////////////
// tH_XLċtH_폜

static int DeleteEmptyFolder(
	TCHAR *deletepath,
	int testflag
) {
	int ret;
	HANDLE hfind = NULL;
	WIN32_FIND_DATA finddata;
	int filecount;
	TCHAR path[MAX_PATH*2];
	TCHAR deletesubpath[MAX_PATH*2];

	filecount = 0;
// LOG_Put_S1( "FindFirstFile: %s\n", deletepath );
	wsprintf( path, "%s*.*", deletepath );
	hfind = FindFirstFile( path, &finddata );
	if ( hfind == INVALID_HANDLE_VALUE ) {
		goto err_findfile;
	}

	while (!0) {
// LOG_Put_S1( "file: %s\n", finddata.cFileName );
		if ( !lstrcmp( finddata.cFileName, "." ) ) {
		} else if ( !lstrcmp( finddata.cFileName, ".." ) ) {
		} else if ( finddata.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM ) {
			filecount++;
		} else if ( finddata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
			wsprintf( deletesubpath, "%s%s\\", deletepath, finddata.cFileName );
			ret = DeleteEmptyFolder( deletesubpath, testflag );
			if ( ret < 0 ) {
				return (ret);
			}
			if ( ret == 0 ) {
// LOG_Put_S1( "Delete Folder: %s\n", deletesubpath );
				if ( !testflag ) {
					LOG_Put( " tH_̍폜: %s\n", deletesubpath );
					ret = RemoveDirectory( deletesubpath );
					if ( ret == 0 ) {
						LOG_Put( "  -->폜s\n", "" );
						filecount++;
					}
				} else {
					LOG_Put( " tH_̍폜ieXgj: %s\n", deletesubpath );
				}
			}
		} else {
			filecount++;
		}
		goto next;

	  next:;
		if ( !FindNextFile( hfind, &finddata ) ) {
			if ( GetLastError() == ERROR_NO_MORE_FILES ) {
				goto endoffolder;
			}
			goto err_findfile;
		}
	}

  endoffolder:;
// LOG_Put_S1( "FindClose: %s\n", deletepath );
	FindClose( hfind );
if (0) {
	if ( testflag ) {
		TCHAR msg[SLEN];
		wsprintf( msg, " tH_ɂt@C/tH_: %4d", filecount );
		LOG_Put_S2( "%s (%s)\n", msg, deletepath );
	}
}
	return (filecount);

  err_quit:;
	if ( hfind ) {
		FindClose( hfind );
	}
	return (ret);

  err_findfile:;
// LOG_Put_S1( "Err_FindFile\n", "" );
	ret = -2;
	goto err_quit;
}

////////////////////////////////////////////////////////////////
// 폜{

static int Poi_Core(
	OPTION_FOLDER *option_folder,
	int testflag
) {
	DISKFREESPACEINFO dfs;
	int ret;
	FILELIST *filelist;
	FOLDERNAMETBL *foldernametbl;
	DWORD idx;
	DWORD delentry;
	TCHAR filename[MAX_PATH*2+1];
	__int64 needsize;
	__int64 freespace;
	__int64 filesize;
	__int64 clustersize;
	int isfirst = 1;

	if ( (!testflag) && option_folder->Stop ) {
		return (0);
	}

	if ( testflag ) {
		LOG_Put( "eXgJn...\n", "" );
		LOG_Put( " [ΏۃtH_                          : %s]\n", option_folder->TargetFolder );
		LOG_Put( " [Ώۊgq                            : %s]\n", option_folder->TargetExt );
		LOG_Put( " [TutH_Ώۂɂ              : %s]\n", (option_folder->FindSubFolder ? "͂" : "" ) );
		LOG_Put( " [ɂȂTutH_͍폜      : %s]\n", (option_folder->DelSubFolder ? "͂" : "" ) );
		LOG_Put( " [ǂݎpt@C폜ΏۂɊ܂߂: %s]\n", (option_folder->DelReadOnly ? "͂" : "" ) );
		LOG_Put( " [Bt@C폜ΏۂɊ܂߂        : %s]\n", (option_folder->DelHidden ? "͂" : "" ) );
		LOG_Put_I1( " [Kvȋ󂫗e                        : %d KoCg]\n", option_folder->FreeSpaceSize );
	} else {
		LOG_Put( "ĎJn...\n", "" );
	}

	ret = GetDiskFreeSpaceInfo( option_folder->TargetFolder, &dfs );
	if ( ret < 0 ) {
		LOG_Put( "fBXNeʎ擾s(%s)\n", option_folder->TargetFolder );
		return (-1);
	}
	if ( testflag ) {
		LOG_Put( " \n", "" );
		LOG_Put_I1( " ݂̋󂫗e(): %d KoCg\n", (int)((dfs.FreeSpace+1048575)/1048576) );
		isfirst = 0;
	}


	if ( testflag ) {
		LOG_Put( " 폜\t@C̈ꗗ:\n", "" );
		LOG_Put( " iɂقǐɍ폜܂j\n", "" );
	}

	ret = GetSortedFileList( option_folder, &filelist, &foldernametbl );
	if ( ret < 0 ) {
		LOG_Put( "t@CXgבւs(%s)\n", option_folder->TargetFolder );
		return (-2);
	}

if (0) {
	if ( testflag ) {
		idx = 0;
		while ( idx < filelist->EntryCount ) {
			SYSTEMTIME ti;
			TCHAR datestr[SLEN];
			TCHAR timestr[SLEN];
	
			delentry = filelist->EntryIdx[idx];
	
			wsprintf(
			  filename, "%s%s", 
			  filelist->Entry[delentry].Folder->Path, 
			  filelist->Entry[delentry].Name
			);
	
			FileTimeToSystemTime( &filelist->Entry[delentry].Time, &ti );
			GetDateFormat( NULL, 0, &ti, "yyyy/MM/dd", datestr, SLEN );
			GetTimeFormat( NULL, 0, &ti, "HH:mm:ss", timestr, SLEN );
			LOG_Put_S3( "   t@C: %s %s %s\n", datestr, timestr, filename );
	
			idx++;
		}
	}
}

	clustersize = dfs.BytePerCluster;
	freespace = dfs.FreeSpace;
	idx = 0;
	while ( idx < filelist->EntryCount ) {
		needsize = ((__int64)(option_folder->FreeSpaceSize))*1024*1024;
		if ( freespace >= needsize ) {
			if ( !testflag ) {
				break;
			}
		}

		if ( isfirst ) {
			LOG_Put_I1( " ݂̋󂫗e(): %d KoCg\n", (int)((dfs.FreeSpace+1048575)/1048576) );
			isfirst = 0;
		}

		delentry = filelist->EntryIdx[idx];

		wsprintf(
		  filename, "%s%s", 
		  filelist->Entry[delentry].Folder->Path, 
		  filelist->Entry[delentry].Name
		);

		if ( filelist->Entry[delentry].Atr & FILE_ATTRIBUTE_READONLY ) {
			if ( option_folder->DelReadOnly ) {
				ret = TRUE;
				if ( !testflag ) {
					ret = SetFileAttributes( filename, FILE_ATTRIBUTE_NORMAL );
				}
				if ( ret == FALSE ) {
					LOG_Put_S1( " ݋֎~̉: %s\n", filename );
					LOG_Put( "  --> s\n", "" );
					goto next;
				}
			} else {
				LOG_Put_S1( " ݋֎~ɂXLbv: %s\n", filename );
				goto next;
			}
		}

		if ( filelist->Entry[delentry].Atr & FILE_ATTRIBUTE_HIDDEN ) {
			if ( option_folder->DelHidden ) {
				// no operation
			} else {
				LOG_Put_S1( " BɂXLbv: %s\n", filename );
				goto next;
			}
		}

		ret = TRUE;
		if ( !testflag ) {
			LOG_Put_S1( " 폜: %s\n", filename );
#if 1
			__try {
				ret = DeleteFile( filename );
			}
			_except(EXCEPTION_EXECUTE_HANDLER)
			{
				ret = FALSE;
			}
#else
			ret = TRUE;
#endif
		} else {
			LOG_Put_S1( " 폜ieXgj: %s\n", filename );
		}
		if ( ret == FALSE ) {
			LOG_Put( "  --> s\n", "" );
			goto next;
		} else {
			filesize = filelist->Entry[delentry].FileSize;
			filesize = (filesize+clustersize-1)/clustersize*clustersize;
			freespace += filesize;
		}

		LOG_Put_I1( " 폜̋󂫗e(\): %d KoCg\n", (int)((freespace+1048575)/1048576) );

	  next:;
		idx++;
	}
	FreeFolderNameTbl( foldernametbl );
	FreeFileList( filelist );

	if ( option_folder->DelSubFolder ) {
		if ( testflag ) {
			LOG_Put( " 폜\tH_̈ꗗ:\n", "" );
		}
		ret = DeleteEmptyFolder( option_folder->TargetFolder, testflag );
	}

	if ( testflag ) {
		LOG_Put( "eXgI...\n", "" );
	} else {
		LOG_Put( "ĎI...\n", "" );
	}

	ret = GetDiskFreeSpaceInfo( option_folder->TargetFolder, &dfs );
	if ( ret < 0 ) {
		LOG_Put( "fBXNeʎ擾s(%s)\n", option_folder->TargetFolder );
		return (-3);
	}
	if ( !isfirst ) {
		LOG_Put_I1( "݂̋󂫗e(): %d KoCg\n", (int)((dfs.FreeSpace+1048575)/1048576) );
	}

	return (0);
}

////////////////////////////////////////////////////////////////
// 폜Xbh

static DWORD WINAPI Thread_Poi_Core(
	LPVOID param
) {
	HANDLE hmutex;
	POITHREADPARAM *ptp;

	ptp = (POITHREADPARAM *)param;

	// Z}tH擾
	hmutex = CreateMutex( NULL, FALSE, "frpoi_Thread_PoiCore" );
	if ( hmutex == NULL ) {
		return (-1);
	}
	Poi_Busy = 1;
	WaitForSingleObject( hmutex, INFINITE );

	Poi_Core( ptp->option, ptp->testflag );

	CloseHandle( hmutex );

	if ( ptp->hwndnotify ) {
		SendMessage( ptp->hwndnotify, WM_USER_MAIN_ENDPOI, 0, 0 );
	}
	Poi_Busy = 0;

	GlobalFree( ptp );
	return (0);
}

////////////////////////////////////////////////////////////////
// 폜Xbh

int Fork_Poi_Main(
	OPTION_FOLDER *option,
	int testflag,
	HWND hwndnotify
) {
	HANDLE thread;
	DWORD threadid;
	POITHREADPARAM *ptp;

	ptp = (POITHREADPARAM *)GlobalAlloc( GPTR, sizeof(POITHREADPARAM) );
	if ( ptp == NULL ) {
		return (-1);
	}
	ptp->option = option;
	ptp->testflag = testflag;
	ptp->hwndnotify = hwndnotify;

	thread = CreateThread(
	  NULL,
	  0,
	  (LPTHREAD_START_ROUTINE)Thread_Poi_Core,
	  (LPDWORD)ptp,
	  0,
	  &threadid
	);
	if ( thread ) {
		CloseHandle( thread );
	}

	return (0);
}

////////////////////////////////////////////////////////////////
// [EOF]
