// wp_folder: folder dialog
// Copyright (C) 2004 GORRY.

#include "wp_folder.h"

static HWND MY_HWND;
static OPTION_FOLDER MY_Option;

////////////////////////////////////////////////////////////////

static int DeleteTest(
	HWND hwnd
);

static int GetTargetFolder(
	void
);

////////////////////////////////////////////////////////////////
// _CAȌ

static int MY_INIT(
	void
) {
	g_SpinEdit_SetLimit( MY_HWND, IDC_EDIT_FOLDER_FREESPACESIZE, IDC_SPIN_FOLDER_FREESPACESIZE, 1024*1024, 1 );
	g_SpinEdit_SetLimit( MY_HWND, IDC_EDIT_FOLDER_INTERVAL, IDC_SPIN_FOLDER_INTERVAL, 60*24, 1 );

	return (0);
}

////////////////////////////////////////////////////////////////
// _CAO̒l̃[h

static int MY_LOAD(
	void
) {
	MY_Option = Option;

	return (0);
}

////////////////////////////////////////////////////////////////
// _CAO̒l̃Z[u

static int MY_SAVE(
	void
) {
	Option = MY_Option;

	return (0);
}

////////////////////////////////////////////////////////////////
// _CAOɒlݒ

static int MY_SET(
	void
) {
	Button_SetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_STOP ), (MY_Option.Stop ? TRUE : FALSE) );
	Edit_SetText( GetDlgItem( MY_HWND, IDC_EDIT_FOLDER_TARGETFOLDER ), MY_Option.TargetFolder );
	Edit_SetText( GetDlgItem( MY_HWND, IDC_EDIT_FOLDER_TARGETEXT ), MY_Option.TargetExt );

	Button_SetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_FINDSUBFOLDER ), (MY_Option.FindSubFolder ? TRUE : FALSE) );
	SendMessage( MY_HWND, WM_COMMAND, MAKEWPARAM(IDC_CHECK_FOLDER_FINDSUBFOLDER,0), 0 );
	Button_SetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_DELSUBFOLDER ), (MY_Option.DelSubFolder ? TRUE : FALSE) );

	g_SpinEdit_SetItem( MY_HWND, IDC_EDIT_FOLDER_FREESPACESIZE, IDC_SPIN_FOLDER_FREESPACESIZE, MY_Option.FreeSpaceSize );
	g_SpinEdit_SetItem( MY_HWND, IDC_EDIT_FOLDER_INTERVAL, IDC_SPIN_FOLDER_INTERVAL, MY_Option.Interval );

	Button_SetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_TOTRASHCAN ), (MY_Option.ToTrashCan ? TRUE : FALSE) );
	Button_SetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_DELREADONLY ), (MY_Option.DelReadOnly ? TRUE : FALSE) );
	Button_SetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_DELHIDDEN ), (MY_Option.DelHidden ? TRUE : FALSE) );

	return (0);
}

////////////////////////////////////////////////////////////////
// _CAO̒l̓ǂݏo

static int MY_GET(
	void
) {
	TCHAR errmsg[SLEN];
	int i1;

	// "l͈͂𒴂Ă܂B(%d`%d)"
	LoadString( ThisInst, IDS_ERR_PARAMOVER, errmsg, sizeof(errmsg) );

	MY_Option.Stop = Button_GetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_STOP ) );
	Edit_GetText( GetDlgItem( MY_HWND, IDC_EDIT_FOLDER_TARGETFOLDER ), MY_Option.TargetFolder, MAX_PATH );
	if ( MY_Option.TargetFolder[0] == '\0' ) {
		OPTION_FOLDER op;
		Option_Folder_Init( &op );
		lstrcpyn( MY_Option.TargetFolder, op.TargetFolder, lstrlen(op.TargetFolder) );
	}
	Edit_GetText( GetDlgItem( MY_HWND, IDC_EDIT_FOLDER_TARGETEXT ), MY_Option.TargetExt, MAX_PATH );

	MY_Option.FindSubFolder = Button_GetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_FINDSUBFOLDER ) );
	MY_Option.DelSubFolder = Button_GetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_DELSUBFOLDER ) );

	if ( g_SpinEdit_GetItem( MY_HWND, IDC_EDIT_FOLDER_FREESPACESIZE, IDC_SPIN_FOLDER_FREESPACESIZE, &i1, errmsg ) ) {
		return (-1);
	}
	MY_Option.FreeSpaceSize = i1;
	if ( g_SpinEdit_GetItem( MY_HWND, IDC_EDIT_FOLDER_INTERVAL, IDC_SPIN_FOLDER_INTERVAL, &i1, errmsg ) ) {
		return (-1);
	}
	MY_Option.Interval = i1;

	MY_Option.ToTrashCan = Button_GetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_TOTRASHCAN ) );
	MY_Option.DelReadOnly = Button_GetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_DELREADONLY ) );
	MY_Option.DelHidden = Button_GetCheck( GetDlgItem( MY_HWND, IDC_CHECK_FOLDER_DELHIDDEN ) );

	return (0);
}

////////////////////////////////////////////////////////////////
// _CAOl̃`FbN

static int MY_CHECK(
	void
) {
	TCHAR errmsg[SLEN];
	TCHAR path[MAX_PATH+16];
	HANDLE hfind = NULL;
    WIN32_FIND_DATA fdata;

	// TargetFolder̃pX`FbN1
//  pass_1:;
	if ( !memcmp(MY_Option.TargetFolder, "\\\\", 2) ) goto pass_2;
	if ( isalpha(MY_Option.TargetFolder[0]) && (MY_Option.TargetFolder[1] == ':') ) goto pass_2;
	goto err_1;

	// TargetFolder̃pX`FbN2
  pass_2:;
	if ( MY_Option.TargetFolder[lstrlen(MY_Option.TargetFolder)-1] == '\\' ) goto pass_3;
	goto err_1;

	// TargetFolder̃pX`FbN3
  pass_3:;
	wsprintf( path, "%s*.*", MY_Option.TargetFolder );
	hfind = FindFirstFile( path, &fdata );
	FindClose( hfind );
	if ( hfind != INVALID_HANDLE_VALUE ) goto pass_4;
	goto err_1;

  pass_4:;
	return (0);

  err_1:;
	// "tH_w肵ĂB"
	LoadString( ThisInst, IDS_ERR_INVALIDFOLDER, errmsg, sizeof(errmsg) );
	MessageBox( MY_HWND, errmsg, NULL, MB_ICONINFORMATION|MB_OK|MB_SETFOREGROUND|MB_TASKMODAL );
	SetFocus( GetDlgItem( MY_HWND, IDC_EDIT_FOLDER_TARGETFOLDER ) );
	return (-1);
}

////////////////////////////////////////////////////////////////
// CvV[W

static BOOL CALLBACK MY_PROC(
	HWND hwnd,
	UINT message,
	WPARAM wParam,
	LPARAM lParam
) {
	WPParam wp;
	WORD id, cmd;
	BOOL result = 0;

	wp.hwnd = hwnd;
	wp.message = message;
	wp.wParam = wParam;
	wp.lParam = lParam;

	switch ( message ) {
	  case WM_INITDIALOG:
		// EBhE쐬
		MY_HWND = hwnd;
		g_CenteringWindow( hwnd, NULL );
		MY_INIT();
		MY_LOAD();
		MY_SET();
		break;

	  case WM_COMMAND:
		id = GET_WM_COMMAND_ID( wParam, lParam );
		cmd = GET_WM_COMMAND_CMD( wParam, lParam );
		switch (id) {
		  case IDC_BUTTON_FOLDER_REFER:
			if ( GetTargetFolder() >= 0 ) {
				Edit_SetText( GetDlgItem( MY_HWND, IDC_EDIT_FOLDER_TARGETFOLDER ), MY_Option.TargetFolder );
			}
			return (TRUE);

		  case IDC_BUTTON_FOLDER_TEST:
			DeleteTest( hwnd );
			return (TRUE);

		  case IDC_CHECK_FOLDER_FINDSUBFOLDER:
			if ( Button_GetCheck( GetDlgItem( hwnd, id ) ) ) {
				EnableWindow( GetDlgItem( hwnd, IDC_CHECK_FOLDER_DELSUBFOLDER ), TRUE );
			} else {
				EnableWindow( GetDlgItem( hwnd, IDC_CHECK_FOLDER_DELSUBFOLDER ), FALSE );
			}
			return (TRUE);

		  case IDOK:
			MY_GET();
			if ( MY_CHECK() < 0 ) {
				return (TRUE);
			}
			MY_SAVE();
			EndDialog( hwnd, 1 );
			return (TRUE);

		  case IDHELP:
//			WinHelp( MY_HWND, HLP_FILE, HELP_CONTEXT, HELP_ID );
			return (TRUE);

		  case IDCANCEL:
			EndDialog( hwnd, 0 );
			return (TRUE);
		}
		break;

	  case WM_DESTROY:
		MY_HWND = NULL;
		break;

	}
	return (result);
}

////////////////////////////////////////////////////////////////
// EBhE쐬

int WP_Folder_Dialog(
	HWND hwnd
) {
	int ret;

	ret = DialogBox( ThisInst, MAKEINTRESOURCE(IDD_FOLDER), hwnd, MY_PROC );
	return (ret);
}

////////////////////////////////////////////////////////////////
// t@C폜eXg

static int DeleteTest(
	HWND hwnd
) {
	MY_GET();
	if ( MY_CHECK() < 0 ) {
		return (-1);
	}
	WP_GetTestLog_Dialog( hwnd, &MY_Option );

	return (0);
}

////////////////////////////////////////////////////////////////
// _CAȌ

static int CALLBACK GetTargetFolder_callback(
	HWND hwnd,
	UINT message,
	LPARAM lParam,
	LPARAM lpData
) {
	switch ( message ) {
	  case BFFM_INITIALIZED:
		SendMessage( hwnd, BFFM_SETSELECTION, TRUE, lpData );
		break;
	}

	return (0);
}

static int GetTargetFolder(
	void
) {
	BROWSEINFO bi;
	LPITEMIDLIST lpii;
	TCHAR newdir[MAX_PATH+1];
	TCHAR msg[SLEN];

	lstrcpy( newdir, MY_Option.TargetFolder );
	bi.hwndOwner = MY_HWND;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = newdir;
	// "ĎtH_w肵Ă"
	LoadString( ThisInst, IDS_MSG_GETTARGETFOLDER, msg, sizeof(msg) );
	bi.lpszTitle = msg;
	bi.ulFlags = BIF_RETURNONLYFSDIRS|BIF_EDITBOX;
	bi.lpfn = GetTargetFolder_callback;
	bi.lParam = (LPARAM)newdir;
	bi.iImage = 0;

	if ( (lpii = SHBrowseForFolder( &bi )) != NULL ) {
		SHGetPathFromIDList( lpii, newdir );
		if ( newdir[lstrlen( newdir )-1] != '\\' ) {
			lstrcat( newdir, "\\" );
		}
		lstrcpy( MY_Option.TargetFolder, newdir );
		CoTaskMemFree( lpii );
		return (0);
	}

	CoTaskMemFree( lpii );
	return (-1);
}


////////////////////////////////////////////////////////////////
// [EOF]
