// wp_gettestlog: get test log
// Copyright (C) 2004 GORRY.

#include "wp_gettestlog.h"

static HWND MY_HWND;

////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// CvV[W

static BOOL CALLBACK MY_PROC(
	HWND hwnd,
	UINT message,
	WPARAM wParam,
	LPARAM lParam
) {
	WPParam wp;
	WORD id, cmd;
	BOOL result = 0;
	HWND hctl;
	int margins;
	int w, h;
	RECT rect_window;
	RECT rect_ok;

	wp.hwnd = hwnd;
	wp.message = message;
	wp.wParam = wParam;
	wp.lParam = lParam;

	switch ( message ) {
	  case WM_INITDIALOG:
		MY_HWND = hwnd;
		g_CenteringWindow( hwnd, NULL );
		hctl = GetDlgItem( hwnd, IDOK );
		EnableWindow( hctl, FALSE );
		hctl = GetDlgItem( hwnd, IDC_RICHEDIT_LOG );
		SendMessage( hctl, EM_SETTEXTMODE, TM_PLAINTEXT, 0 );
		SendMessage( hwnd, WM_SIZE, 0, 0 );
		HWND_PutLog = hwnd;
		Fork_Poi_Main( (OPTION_FOLDER *)lParam, 1, hwnd );
		break;

	  case WM_USER_MAIN_ENDPOI:
		hctl = GetDlgItem( hwnd, IDOK );
		EnableWindow( hctl, TRUE );
		break;

	  case WM_APP_LOGMSG:
		hctl = GetDlgItem( hwnd, IDC_RICHEDIT_LOG );
		margins = SendMessage( hctl, EM_GETMARGINS, 0, -1 );
//		SendMessage( hctl, EM_SETSEL, 0, -1 );
		SendMessage( hctl, EM_SETSEL, -1, -1 );
//		SendMessage( hctl, EM_REPLACESEL, FALSE, (LPARAM)"\n" );
		SendMessage( hctl, EM_REPLACESEL, FALSE, lParam );
		SendMessage( hctl, EM_SCROLLCARET, 0, 0 );
		return (TRUE);

	  case WM_COMMAND:
		id = GET_WM_COMMAND_ID( wParam, lParam );
		cmd = GET_WM_COMMAND_CMD( wParam, lParam );
		switch (id) {
		  case IDOK:
			EndDialog( hwnd, 1 );
			return (TRUE);

		  case IDHELP:
//			WinHelp( MY_HWND, HLP_FILE, HELP_CONTEXT, HELP_ID );
			return (TRUE);

		  case IDCANCEL:
			EndDialog( hwnd, 0 );
			return (TRUE);
		}
		break;

	  case WM_SIZE:
		GetWindowRect( hwnd, &rect_window );
		GetWindowRect( GetDlgItem(hwnd, IDOK), &rect_ok );
		rect_ok.right -= rect_ok.left;
		rect_ok.bottom -= rect_ok.top;
		w = rect_window.right - rect_window.left
		                      - (GetSystemMetrics(SM_CXSIZEFRAME)*2);
		h = rect_window.bottom - rect_window.top
		                       - (GetSystemMetrics(SM_CYSIZEFRAME)*2)
		                       - rect_ok.bottom*12/10
		                       - GetSystemMetrics(SM_CYCAPTION);
		MoveWindow(
		  GetDlgItem(hwnd, IDC_RICHEDIT_LOG),
		  0, 0, w, h,
		  TRUE
		);
		MoveWindow(
		  GetDlgItem(hwnd, IDOK),
		  w-(rect_ok.right*12/10),
		  h+rect_ok.bottom/10,
		  rect_ok.right, rect_ok.bottom,
		  TRUE
		);

		break;

	  case WM_DESTROY:
		HWND_PutLog = NULL;
		MY_HWND = NULL;
		break;

	}
	return (result);
}

////////////////////////////////////////////////////////////////
// EBhE쐬

int WP_GetTestLog_Dialog(
	HWND hwnd,
	OPTION_FOLDER *option
) {
	int ret;

	ret = DialogBoxParam( ThisInst, MAKEINTRESOURCE(IDD_GETTESTLOG), hwnd, MY_PROC, (LPARAM)option );
	return (ret);
}

////////////////////////////////////////////////////////////////
// [EOF]
